def calc() {
    return env.GIT_COMMIT
}


pipeline {
    agent any
    
    environment {
         imageTag=calc()// fonction groovy de gitversion
    }
   
    stages {
        stage('BuildProject') {
            when {
                anyOf {
                    branch 'develop'
                    branch 'release/*'
                } 
            }
            steps {
                sh 'docker build -t dockertests -f Dockerfile_build .'
            }
        }
        stage('Test') {
            when {
                anyOf {
                    branch 'develop'
                    branch 'release/*'
                } 
            }
            steps {
                sh 'docker run dockertests dotnet test'
            }
        }
       stage('PublishProject') {
           when {
                anyOf {
                    branch 'develop'
                    branch 'release/*'
                } 
            }
            steps {
                sh "docker build -t dekracr.azurecr.io/is4/helloworld:${env.imageTag} ."
            }
        }
        stage('PushAzureRegistry') {
            when {
                anyOf {
                    branch 'develop'
                    branch 'release/*'
                } 
            }
            steps {
                sh 'docker login dekracr.azurecr.io -u dekracr -p JyQJbKxiLTmfexQ8Aas5ewGX8ZrW5/Sn'
                sh  "docker push  dekracr.azurecr.io/is4/helloworld:${env.imageTag}" 
                
            }
        }
        stage('Kustomize_CI') {
            when { branch 'develop' }
            steps {
                echo 'cd kustomize/overlays/ephemeral'
                echo "kustomize edit set image yy/xxx=dekracr.azurecr.io/is4/helloworld:${env.imageTag} "
                echo "kustomize edit set namespace develop"
                echo ' kustomize build | k apply -f -'
            }
        }
        stage('Kustomize_Release') {
            when { branch 'release/*' }
            steps {
                echo 'cd kustomize/overlays/ephemeral'
                echo "kustomize edit set image yy/xxx=dekracr.azurecr.io/is4/helloworld:${env.imageTag} "
                echo "kustomize edit set namespace release"
                echo ' kustomize build | k apply -f -'
            }
        }

        stage('Kustomize_ba') {
            when { 
                tag "ba" 
            }
            steps {
                echo 'cd kustomize/overlays/ephemeral'
                echo 'docker login dekracr.azurecr.io -u dekracr -p JyQJbKxiLTmfexQ8Aas5ewGX8ZrW5/Sn'
                echo "docker pull dekracr.azurecr.io/is4/helloworld:${env.imageTag}"
                echo "docker tag dekracr.azurecr.io/is4/helloworld:${env.imageTag} dekracr.azurecr.io/is4/helloworld:ba-${env.branchSuffix}"
                echo "docker push dekracr.azurecr.io/is4/helloworld:ba-${env.branchSuffix}"
                echo "kustomize edit set image yy/xxx=dekracr.azurecr.io/is4/helloworld:ba-${env.branchSuffix}"
                echo "kustomize edit set namespace ba"
                echo ' kustomize build | k apply -f -'
            }
        }

        stage('Kustomize_preprod') {
            when { 
                tag "preprod" 
            }
            steps {
                echo 'cd kustomize/overlays/preprod'
                // echo "git rev-list -n 1 ba == ${env.imageTag} => exit" a voir plus tard
                echo 'docker login dekracr.azurecr.io -u dekracr -p JyQJbKxiLTmfexQ8Aas5ewGX8ZrW5/Sn'
                echo "docker pull dekracr.azurecr.io/is4/helloworld:${env.imageTag}"
                echo "docker tag dekracr.azurecr.io/is4/helloworld:${env.imageTag} cris4aks.azurecr.io/is4/helloworld:preprod-${env.branchSuffix}"
                echo 'docker login cris4aks.azurecr.io -u servicePrincipalId -p password'
                echo "docker push cris4aks.azurecr.io/is4/helloworld:preprod-${env.branchSuffix}"
                echo "kustomize edit set image yy/xxx=cris4aks.azurecr.io/is4/helloworld:preprod-${env.branchSuffix}"
                echo "kustomize edit set namespace integ"
                echo "kustomize build -o preprod-${env.branchSuffix}.yaml"
                
            }
        }

    }

}